	.file	"sprite.c"
	.local	slock
	.comm	slock,24,4
	.local	sprite_valid
	.comm	sprite_valid,4,4
	.local	sprite_start_x
	.comm	sprite_start_x,4,4
	.local	sprite_start_y
	.comm	sprite_start_y,4,4
	.local	sprite_data
	.comm	sprite_data,4,4
	.local	sprite_start
	.comm	sprite_start,4,4
	.section	.rodata.str1.32,"aMS",@progbits,1
	.align 32
.LC0:
	.string	"sprite_init(): invalid origin value `%s'\n"
	.align 32
.LC1:
	.string	"sprite_init(): invalid origin value `%s,%s'\n"
	.align 32
.LC2:
	.string	"sprite_init(): cannot read sprite file `%s' (bad format?)\n"
	.text
	.p2align 4,,15
.globl sprite_init
	.type	sprite_init, @function
sprite_init:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$40, %esp
	movl	%ebx, -8(%ebp)
	movl	sprite_file, %eax
	movl	%esi, -4(%ebp)
	testl	%eax, %eax
	je	.L3
	movl	sprite_origin, %eax
	testl	%eax, %eax
	jne	.L2
.L3:
	xorl	%edx, %edx
.L1:
	movl	-8(%ebp), %ebx
	movl	%edx, %eax
	movl	-4(%ebp), %esi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.p2align 4,,7
.L2:
	movl	%eax, 4(%esp)
	movl	$10, %ecx
	leal	-24(%ebp), %esi
	movl	%ecx, 8(%esp)
	movl	%esi, %ebx
	movl	%esi, (%esp)
	call	strncpy
	movzbl	-24(%ebp), %eax
	movb	$0, -15(%ebp)
	testb	%al, %al
	je	.L19
	cmpb	$44, %al
	je	.L20
	.p2align 4,,15
.L9:
	incl	%ebx
	movzbl	(%ebx), %eax
	testb	%al, %al
	je	.L21
	cmpb	$44, %al
	jne	.L9
.L5:
	testb	%al, %al
	jne	.L10
.L21:
	movl	%esi, 4(%esp)
	movl	$.LC0, (%esp)
.L23:
	call	printf
.L22:
	movl	$1, %edx
	jmp	.L1
.L10:
	movb	$0, (%ebx)
	xorl	%ecx, %ecx
	movl	$10, %edx
	movl	%ecx, 12(%esp)
	incl	%ebx
	xorl	%ecx, %ecx
	movl	%edx, 8(%esp)
	movl	%ecx, 4(%esp)
	movl	%esi, (%esp)
	call	__strtol_internal
	movl	%eax, sprite_start_x
	xorl	%edx, %edx
	movl	$10, %eax
	movl	%edx, 12(%esp)
	xorl	%edx, %edx
	movl	%eax, 8(%esp)
	movl	%edx, 4(%esp)
	movl	%ebx, (%esp)
	call	__strtol_internal
	cmpl	$719, sprite_start_x
	movl	%eax, sprite_start_y
	ja	.L16
	testl	%eax, %eax
	js	.L16
	cmpl	$575, %eax
	jle	.L15
.L16:
	movl	%ebx, 8(%esp)
	movl	%esi, 4(%esp)
	movl	$.LC1, (%esp)
	call	printf
	jmp	.L22
.L15:
	call	read_sprite
	xorl	%edx, %edx
	testl	%eax, %eax
	je	.L1
	movl	$.LC2, (%esp)
	movl	sprite_file, %ebx
	movl	%ebx, 4(%esp)
	jmp	.L23
.L20:
	movb	$44, %al
	jmp	.L5
.L19:
	movzbl	(%esi), %eax
	jmp	.L5
	.size	sprite_init, .-sprite_init
	.section	.rodata.str1.1,"aMS",@progbits,1
.LC3:
	.string	"rb"
	.text
	.p2align 4,,15
.globl read_sprite
	.type	read_sprite, @function
read_sprite:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$1128, %esp
	movl	%ebx, -12(%ebp)
	movl	sprite_file, %edx
	movl	%esi, -8(%ebp)
	movl	%edi, -4(%ebp)
	testl	%edx, %edx
	jne	.L47
.L46:
	xorl	%eax, %eax
.L24:
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.p2align 4,,7
.L47:
	movl	$slock, (%esp)
	call	pthread_mutex_lock
	movl	sprite_file, %edx
	xorl	%ecx, %ecx
	movl	$.LC3, %eax
	movl	%ecx, sprite_valid
	movl	%eax, 4(%esp)
	movl	%edx, (%esp)
	call	fopen
	testl	%eax, %eax
	movl	%eax, %ebx
	je	.L45
	movl	%eax, 12(%esp)
	movl	$2, %edx
	leal	-1112(%ebp), %edi
	movl	%edx, 4(%esp)
	movl	$539, %eax
	movl	%eax, 8(%esp)
	movl	%edi, (%esp)
	call	fread
	cmpl	$539, %eax
	je	.L48
.L44:
	movl	%ebx, (%esp)
	call	fclose
.L45:
	movl	$slock, (%esp)
	call	pthread_mutex_unlock
	movl	$1, %eax
	jmp	.L24
	.p2align 4,,7
.L48:
	cmpw	$19778, -1112(%ebp)
	je	.L49
.L33:
	testl	%ebx, %ebx
	jne	.L44
	jmp	.L45
.L49:
	cmpw	$1078, -1102(%ebp)
	jne	.L33
	cmpw	$1, -1086(%ebp)
	jne	.L33
	cmpw	$8, -1084(%ebp)
	jne	.L33
	movzwl	-1094(%ebp), %edx
	movl	sprite_data, %ecx
	movzwl	-1090(%ebp), %esi
	leal	3(%edx), %eax
	andl	$2147483644, %eax
	movl	%eax, sprite_stride
	leal	-1(%esi), %edi
	imull	%edi, %eax
	movl	%esi, sprite_size_y
	movl	%edx, sprite_size_x
	movl	%ecx, (%esp)
	leal	(%edx,%eax), %esi
	movl	%esi, 4(%esp)
	call	realloc
	movl	%eax, sprite_data
	testl	%eax, %eax
	je	.L44
	movl	%ebx, 12(%esp)
	movl	$1, %ecx
	movl	%esi, 8(%esp)
	movl	%ecx, 4(%esp)
	movl	%eax, (%esp)
	call	fread
	cmpl	%esi, %eax
	jne	.L44
	movl	%ebx, (%esp)
	call	fclose
	movl	$slock, (%esp)
	movl	sprite_start_x, %edx
	movl	$720, %ecx
	movl	sprite_size_x, %esi
	movl	sprite_start_y, %ebx
	subl	%edx, %ecx
	cmpl	%ecx, %esi
	movl	sprite_data, %edx
	cmovg	%ecx, %esi
	movl	$576, %ecx
	subl	%ebx, %ecx
	movl	%esi, sprite_size_x
	movl	sprite_stride, %ebx
	movl	sprite_size_y, %esi
	cmpl	%ecx, %esi
	cmovg	%ecx, %esi
	imull	%ebx, %edi
	negl	%ebx
	movl	%esi, sprite_size_y
	movl	%ebx, sprite_stride
	addl	%edx, %edi
	movl	%edi, sprite_start
	movl	$1, %edi
	movl	%edi, sprite_valid
	call	pthread_mutex_unlock
	jmp	.L46
	.size	read_sprite, .-read_sprite
	.p2align 4,,15
.globl draw_sprite
	.type	draw_sprite, @function
draw_sprite:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$56, %esp
	movl	%ebx, -12(%ebp)
	movl	8(%ebp), %edx
	movl	12(%ebp), %eax
	movl	%esi, -8(%ebp)
	movl	%edi, -4(%ebp)
	movl	%edx, -24(%ebp)
	movl	sprite_file, %edx
	movl	%eax, -28(%ebp)
	testl	%edx, %edx
	jne	.L225
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.p2align 4,,7
.L225:
	movl	$slock, (%esp)
	call	pthread_mutex_lock
	movl	sprite_valid, %ecx
	testl	%ecx, %ecx
	jne	.L226
.L218:
	movl	$slock, 8(%ebp)
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	jmp	pthread_mutex_unlock
.L226:
	movl	sprite_size_y, %esi
	xorl	%ebx, %ebx
	cmpl	%esi, %ebx
	movl	%esi, -32(%ebp)
	jge	.L218
	movl	sprite_start_y, %edx
	movl	sprite_stride, %eax
	movl	sprite_start_x, %edi
	movl	%edx, -44(%ebp)
	movl	sprite_start, %edx
	movl	%eax, -36(%ebp)
	movl	%edi, -40(%ebp)
	.p2align 4,,15
.L223:
	movl	%edx, -16(%ebp)
	movl	-44(%ebp), %esi
	movl	-28(%ebp), %ecx
	movl	-40(%ebp), %edi
	leal	(%esi,%ebx), %eax
	imull	%ecx, %eax
	movl	-24(%ebp), %esi
	addl	%edi, %eax
	addl	%esi, %eax
	movl	%eax, -20(%ebp)
#APP
									
    movl sprite_size_x, %ecx		# load counter and divide by 8	
    shrl $3, %ecx						
    movl -16(%ebp), %esi		# load sprite address		
    movl -20(%ebp), %edi		# load image address		
    movl $8, %eax		# load constant value 8		
    .spriteloop:						
    movq (%edi), %mm0		# load image value		
    movq (%esi), %mm1		# load sprite value		
    paddusb %mm1, %mm0	# do it				
    movq %mm0, (%edi)		# save value			
    addl %eax, %esi		# increment addresses		
    addl %eac, %edi						
    decl %ecx			# decrease counter		
    jnz .spriteloop		# loop over			
    emms			# reset MMX state		
  
#NO_APP
	movl	-36(%ebp), %ecx
	incl	%ebx
	addl	%ecx, %edx
	cmpl	-32(%ebp), %ebx
	jl	.L223
	jmp	.L218
	.size	draw_sprite, .-draw_sprite
	.local	sprite_stride
	.comm	sprite_stride,4,4
	.local	sprite_size_x
	.comm	sprite_size_x,4,4
	.local	sprite_size_y
	.comm	sprite_size_y,4,4
	.section	.note.GNU-stack,"",@progbits
	.ident	"GCC: (GNU) 3.3.5 (Debian 1:3.3.5-5)"
