/*
Stream output module for lvstream.
lvstream (C) 2005 Martin J. Fiedler <martin.fiedler@gmx.net>

lvstream is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

lvstream is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with lvstream; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef __STREAM_H__
#define __STREAM_H__

#define AUDIO_STREAM    0
#define LO_VIDEO_STREAM 1
#define HI_VIDEO_STREAM 2

extern int lo_current_au;
extern int hi_current_au;

int stream_init(void);
int stream_close(void);

void stream_write(int stream, uint8_t *packet, int length, uint64_t timestamp);
void stream_next_au(int stream, double timestamp, int eos);

#endif/*__STREAM_H__*/
